@echo off
echo off
if "%1"=="TitleFileNow" goto Titler
if "%1"=="BeginNow" goto Begin
if "%1"=="LogError" goto LogError
@goto Start
goto DOSLow
:Start
echo 
echo Zac Schroff's ZipTitler v2.1 Batch job, for DOS 3.30+ and PKZip 0.92+.
echo (No Log file variant)
if "%1"=="" goto NoParam
if "%2"=="" goto NoParam
if exist %2 goto XT010
if exist %1%2 goto XT020
if exist %1\%2 goto XT030
goto NoTitle
:XT010
if exist %1.Zi? goto XT013
if exist %1 goto XT014
if exist %1*.Zi? goto XT011
if exist %1\*.Zi? goto XT012
goto NoZip
:XT011
call %0 BeginNow %1*.Zi? %2 %3
goto EndNow
:XT012
call %0 BeginNow %1\*.Zi? %2 %3
goto EndNow
:XT013
call %0 BeginNow %1.Zi? %2 %3
goto EndNow
:XT014
call %0 BeginNow %1 %2 %3
goto EndNow
:XT020
call %0 BeginNow %1*.Zi? %1%2 %3
goto EndNow
:XT030
call %0 BeginNow %1\*.Zi? %1\%2 %3
goto EndNow
:Begin
if exist ZipTitle.Err del ZipTitle.Err <Nul >Nul
:Doit
for %%f in (%2) do call %0 TitleFileNow -zq%4 %%f %3
echo 
goto Endit
:Titler
echo 
echo   ZipTitle : Processing file `%3'...
PKZip.Exe -k %2 %3 <%4 >nul
if errorlevel 18 goto UndefErr
if errorlevel 17 goto TooMany
if errorlevel 16 goto BadParm
if errorlevel 15 goto ReadOnly
if errorlevel 14 goto DiscFull
if errorlevel 13 goto NotFound
if errorlevel 12 goto NoFiles
if errorlevel 4 goto LowMem
if errorlevel 2 goto BadZip
if errorlevel 1 goto BadFile
echo   ZipTitle : File successfully titled
goto EndNow
:UnDefErr
echo   ZipTitle : Undefined PKZip error
goto EndNow
:TooMany
echo   ZipTitle : Too many files for PKZip
goto EndNow
:BadParm
echo   ZipTitle : Bad PKZip parameter or parameters
goto EndNow
:ReadOnly
echo   ZipTitle : Zip file is read-only
%comspec% /c%0 LogError Zipfileisread-only%3>>ZipTitle.Err
goto EndNow
:DiscFull
echo   ZipTitle : Disc is full
%comspec% /c%0 LogError Discisfull%3>>ZipTitle.Err
goto EndNow
:NotFound
echo   Ziptitle : PKZip could not find a file
goto EndNow
:NoFiles
echo   ZipTitle : No files specified to PKZip
goto EndNow
:LowMem
echo   ZipTitle : Not enough memory
%comspec% /c%0 LogError Notenoughmemoryorspace%3>>ZipTitle.Err
goto EndNow
:BadZip
echo   ZipTitle : Zip file is corrupt
%comspec% /c%0 LogError Zipfileiscorrupt%3>>ZipTitle.Err
goto EndNow
:BadFile
echo   ZipTitle : Bad file-name
goto EndNow
:LogError
prompt $d $t : %2
echo on

@echo off
exit
goto EndNow
:NoZip
echo 
echo Could not find specified ZipFile : `%1'
echo 
if not exist %2 goto NoTitle2
goto EndNow
:NoTitle
echo 
:NoTitle2
echo Could not find specified title file : `%2'
echo 
goto EndNow
:NoParam
echo 
echo Calling syntax : [call] %0 zips title [zipopts]
echo 
echo Where `zips' is the filespec for the zip-files you wish titled.
echo      `title' is the file containing the title to use
echo      `zipopts' are any specific options you wish passed to PKZip, this is
echo                optional and is ignored if it is not included.
echo 
echo `call' should only be included if called from within another batch job.
echo `zips' may include a wildcard filespec and path.  Extension is optional.
echo        It may also be a path to a directory containing files `*.Zip.'
echo `title' may include a path, wildcards not allowed.  Extension required.
echo         If this is not found and `zips' is a path to a directory, this will
echo         be looked for also in the directory specified by `zips.'
echo `zipopts' should be any valid PKZip options, enter `PKZIP -?' for details.
echo 
echo PKZip.Exe must be in the current directory or the DOS search path.
echo 
echo It is advised that you run this batch job from a hard disc or RAMDisc...
echo 
goto EndNow
:DOSLow
echo 
echo Zac Schroff's ZipTitler v2.1 Batch job, for DOS 3.30+ and PKZip 0.92+.
echo 
echo This batch job requires DOS 3.3 to operate.  Please execute under a DOS
echo version 3.3x or 5.xx or higher.  Not tested under DOS 4.0x.
echo 
goto EndNow
:EndIt
echo Thank you for using Zac Schroff's ZipTitler.  If you have enjoyed the
echo experience of this batch job, why not share it with your friends?
echo 
:EndNow

